# ---------------------------------------------------------------------------
# TopModelPreProcessor.py
# Creates the soil index required by Top Model
# by Collin Bode and Stefano Zanardo
# Created on: Mon Oct 24 2011 02:26:36 PM
#   (generated by ArcGIS/ModelBuilder)
# ---------------------------------------------------------------------------

# Import system modules
import sys, string, os, arcgisscripting

# Create the Geoprocessor object
gp = arcgisscripting.create()
gp.CheckOutExtension("spatial")
gp.overwriteoutput = 1


# User Input variables...
dir = "B:\\topmodel_fox\\"
dem = "fox10mdem"

# Grid names
outname = dem[:8]
dem = dir+dem
slope = dir+"slope"
fill = dir+"fill"
flowdir = dir+"flowdir"
acc = dir+"acc"
index = dir+outname+"index"
print "START processing on "+dem

# Process: Sinkfill...
print "Sinkfilling..."
gp.Fill_sa(dem,fill)

# Process: Flow Direction...
gp.FlowDirection_sa(fill, flowdir, "NORMAL")
print "Flow Direction..."

# Process: Flow Accumulation...
gp.FlowAccumulation_sa(flowdir, acc, "", "FLOAT")
print "Flow Accumulation..."

# Process: Slope...
gp.Slope_sa(dem, slope, "PERCENT_RISE", "1")
print "Percent Slope..."

# Process: Single Output Map Algebra...
#mapalgebra = "LN(("+acc+" + 0.001) / (("+slope+" / 100) + 0.001))" <-- incorrect
mapalgebra = "LN(("+acc+" + 1) / ("+slope+" / 100))"
print "Calculating index using mapalgebra: "+mapalgebra
gp.SingleOutputMapAlgebra_sa(mapalgebra, index)

print "Processing DONE! "+index+" created."
